import pygame

import random

class Bitstream(pygame.sprite.Sprite):
    def __init__(self,start_code,font):
        pygame.sprite.Sprite.__init__(self)
        if type(start_code) == int and 0 <= start_code < 128:
            self.code = [int(x) for x in bin(start_code)[2:].zfill(8)]
        elif type(start_code) == string:
            try:
                code = int(start_code,2)
            except:
                raise ValueError("Invalid byte: "+start_code)
            if 0 <= code < 128:
                self.code = [int(x) for x in bin(code)[2:].zfill(8)]
            else:
                raise ValueError("Invalid byte: "+start_code)
        elif type(start_code) == list:
            pass
        else:
            raise ValueError("Invalid byte: "+str(start_code))
        self.font = font
        self.bots = []
        self.bitrects = []

    def __getitem__(self,index):
        return self.code[index]

    def __setitem__(self,index,value):
        if value in (0,1):
            self.code[index] = value
        elif value in "01":
            self.code[index] = int(value)

    def update(self):
        char = int("".join(str(b) for b in self.code),2)
        if 32 <= char < 127:
            charsurf = self.font.render(chr(char),False,(127,127,127),(0,0,0))
        else:
            charsurf = pygame.Surface((10,18))
            for x in range(10):
                charsurf.set_at((random.randint(0,9),random.randint(0,16)),
                                (127,127,127))
        self.bitrects = []
        backsurf = pygame.Surface((320,17*32))
        backsurf.blit(pygame.transform.scale(charsurf,(320,17*32)),(0,0))
        for bit in range(8):
            cs = self.font.render(str(self.code[bit]),False,(255,255,255))
            bigcs = pygame.transform.scale(cs,(cs.get_width()*4,cs.get_height()*4))
            self.bitrects.append(backsurf.blit(bigcs,(bit*40,320)))
        self.image = backsurf
        self.rect = pygame.Rect(0,0,0,0)
